/*\
var fs = require('fs');
var file = 'evenflow_lyrics.txt';

// read file from current directory
fs.readFile(file, 'utf8', function (err, data) {

  if (err) throw err;

  var wordsArray = splitByWords(data);
  var wordsMap = createWordMap(wordsArray);
  var finalWordsArray = sortByCount(wordsMap);

  console.log(finalWordsArray);
  console.log('The word "' + finalWordsArray[0].key + '" appears the most in the file ' +
    finalWordsArray[0].value + ' times');

});
*/

function getWordsArray (s) {
  // Normalize
  s = s.toLowerCase();
  // Strip quotes and brackets
  s = s.replace(/["“”(\[{}\])]|\B['‘]([^'’]+)['’]/g, '$1');
  // Strip dashes and ellipses
  s = s.replace(/[‒–—―…]|--|\.\.\./g, ' ');
  // Strip punctuation marks
  var punct = /[!-/:-@[-`{-~¡-©«-¬®-±´¶-¸»¿×÷˂-˅˒-˟˥-˫˭˯-˿͵;΄-΅·϶҂՚-՟։-֊־׀׃׆׳-״؆-؏؛؞-؟٪-٭۔۩۽-۾܀-܍߶-߹।-॥॰৲-৳৺૱୰௳-௺౿ೱ-ೲ൹෴฿๏๚-๛༁-༗༚-༟༴༶༸༺-༽྅྾-࿅࿇-࿌࿎-࿔၊-၏႞-႟჻፠-፨᎐-᎙᙭-᙮᚛-᚜᛫-᛭᜵-᜶។-៖៘-៛᠀-᠊᥀᥄-᥅᧞-᧿᨞-᨟᭚-᭪᭴-᭼᰻-᰿᱾-᱿᾽᾿-῁῍-῏῝-῟῭-`´-῾\u2000-\u206e⁺-⁾₊-₎₠-₵℀-℁℃-℆℈-℉℔№-℘℞-℣℥℧℩℮℺-℻⅀-⅄⅊-⅍⅏←-⏧␀-␦⑀-⑊⒜-ⓩ─-⚝⚠-⚼⛀-⛃✁-✄✆-✉✌-✧✩-❋❍❏-❒❖❘-❞❡-❵➔➘-➯➱-➾⟀-⟊⟌⟐-⭌⭐-⭔⳥-⳪⳹-⳼⳾-⳿⸀-\u2e7e⺀-⺙⺛-⻳⼀-⿕⿰-⿻\u3000-〿゛-゜゠・㆐-㆑㆖-㆟㇀-㇣㈀-㈞㈪-㉃㉐㉠-㉿㊊-㊰㋀-㋾㌀-㏿䷀-䷿꒐-꓆꘍-꘏꙳꙾꜀-꜖꜠-꜡꞉-꞊꠨-꠫꡴-꡷꣎-꣏꤮-꤯꥟꩜-꩟﬩﴾-﴿﷼-﷽︐-︙︰-﹒﹔-﹦﹨-﹫！-／：-＠［-｀｛-･￠-￦￨-￮￼-�]|\ud800[\udd00-\udd02\udd37-\udd3f\udd79-\udd89\udd90-\udd9b\uddd0-\uddfc\udf9f\udfd0]|\ud802[\udd1f\udd3f\ude50-\ude58]|\ud809[\udc00-\udc7e]|\ud834[\udc00-\udcf5\udd00-\udd26\udd29-\udd64\udd6a-\udd6c\udd83-\udd84\udd8c-\udda9\uddae-\udddd\ude00-\ude41\ude45\udf00-\udf56]|\ud835[\udec1\udedb\udefb\udf15\udf35\udf4f\udf6f\udf89\udfa9\udfc3]|\ud83c[\udc00-\udc2b\udc30-\udc93]/g;
  s = s.replace(punct,' ');
  //s = s.replace(/[!?;:.,]\B/g, '');
  //s = s.replace(/[!?;:.,=]\B/g, ' ');
  
  //remove digits
  s = s.replace(/[0-9]/g, ' ');

  //remove all single characters
  s = s.replace(/(^| ).(( ).)*( |$)/g, ' ');
  
  // split string by spaces (including spaces, tabs, and newlines) 
  var wordsArray = s.split(/\s+/);
  //console.log(wordsArray);
  return wordsArray;
}


function createWordMap (wordsArray) {
  // create map for word counts
  var wordsMap = {};
  /*
    wordsMap = {
      'Oh': 2,
      'Feelin': 1,
      ...
    }
  */
  wordsArray.forEach(function (key) {
    if (wordsMap.hasOwnProperty(key)) {
      wordsMap[key]++;
    } else {
      wordsMap[key] = 1;
    }
  });

  return wordsMap;
}

function sortByCount (wordsMap) {

  // sort by count in ascending order
  var finalWordsArray = [];
  finalWordsArray = Object.keys(wordsMap).map(function(key) {
    return {
      "word": key,
      "occurrence": wordsMap[key]
    };
  });

  finalWordsArray.sort(function(a, b) {
    return -b.value + a.value;
  });

  return finalWordsArray;
}

function word_freq(text){
	//console.log(createWordMap(getWordsArray(text)));
	return sortByCount(createWordMap(getWordsArray(text)));
}

function print(o){
    var str='';

    for(var p in JSON.stringify(o)){
		
        if(typeof o[p] == 'string'){
            str+= p + ': ' + o[p]+'; </br>';
        }else{
			//str+= p + ':' + print(o[p]) + '<br>';
            str+= p + ': { </br>' + print(o[p]) + '}';
        }
		
        //str+= p + ': ' + o[p]+'; <br>';		
    }

    return str;
}

function output_freq(text){
	document.getElementById("output_passage").innerHTML = text;
	document.getElementById("output_passage").style.visibility = 'visible';
	var result_map = new Map();
	result_map = word_freq(text);
	//alert(result_map);
	var result = "";
	//result = json_to_table(result_map,"word_freq_table","sortable");
	result = json_to_table(result_map,"word_freq_table","sortable", 'Download');
	document.getElementById("freq").innerHTML = result;
	sorttable.makeSortable(document.getElementById('word_freq_table'));
//alert(document.getElementById('word_freq_table').innerHTML);
	//console.log(document.getElementById('word_freq_table').innerHTML);
	//highlight(document.getElementById("freq"),"the");
	//console.log(document.getElementById("passage").innerHTML);
}

function hi(outpt_passage,word){
	//alert(outpt_passage.value);
 	var hi = new Hilitor(outpt_passage);
	hi.apply(word);
	//alert(textarea.value);
}